
# q-expansion of newform 704.2.a.f, downloaded from the LMFDB on 27 April 2024.

# We generate the q-expansion using the Hecke eigenvalues a_p at the primes.
# Each a_p is given as a linear combination
# of the following basis for the coefficient ring.

def make_data():

    from sage.all import prod, floor, prime_powers, gcd, QQ, primes_first_n, next_prime, RR

    def discrete_log(elts, gens, mod):
        # algorithm 2.2, page 16 of https://arxiv.org/abs/0903.2785
        def table_gens(gens, mod):
            T = [1]
            n = len(gens)
            r = [None]*n
            s = [None]*n
            for i in range(n):
                beta = gens[i]
                r[i] = 1
                N = len(T)
                while beta not in T:
                    for Tj in T[:N]:
                        T.append((beta*Tj) % mod)
                    beta = (beta*gens[i]) % mod
                    r[i] += 1
                s[i] = T.index(beta)
            return T, r, s
        T, r, s = table_gens(gens, mod)
        n = len(gens)
        N = [ prod(r[:j]) for j in range(n) ]
        Z = lambda s: [ (floor(s/N[j]) % r[j]) for j in range(n)]
        return [Z(T.index(elt % mod)) for elt in elts]
    def extend_multiplicatively(an):
        for pp in prime_powers(len(an)-1):
            for k in range(1, (len(an) - 1)//pp + 1):
                if gcd(k, pp) == 1:
                    an[pp*k] = an[pp]*an[k]
    from sage.all import PolynomialRing, NumberField
    R = PolynomialRing(QQ, "x")
    f = R(poly_data)
    K = NumberField(f, "a")
    betas = [K.gens()[0]**i for i in range(len(poly_data))]
    convert_elt_to_field = lambda elt: sum(c*beta for c, beta in zip(elt, betas))
    # convert aps to K elements
    primes = primes_first_n(len(aps_data))
    good_primes = [p for p in primes if not p.divides(level)]
    aps = map(convert_elt_to_field, aps_data)
    if not hecke_ring_character_values:
        # trivial character
        char_values = dict(zip(good_primes, [1]*len(good_primes)))
    else:
        gens = [elt[0] for elt in hecke_ring_character_values]
        gens_values = [convert_elt_to_field(elt[1]) for elt in hecke_ring_character_values]
        char_values = dict([(
            p,prod(g**k for g, k in zip(gens_values, elt)))
            for p, elt in zip(good_primes, discrete_log(good_primes, gens, level))
            ])
    an_list_bound = next_prime(primes[-1])
    an = [0]*an_list_bound
    an[1] = 1
    
    from sage.all import PowerSeriesRing
    PS = PowerSeriesRing(K, "q")
    for p, ap in zip(primes, aps):
        if p.divides(level):
            euler_factor = [1, -ap]
        else:
            euler_factor = [1, -ap, p**(weight - 1) * char_values[p]]
        k = RR(an_list_bound).log(p).floor() + 1
        foo = (1/PS(euler_factor)).padded_list(k)
        for i in range(1, k):
            an[p**i] = foo[i]
    extend_multiplicatively(an)
    return PS(an)
level = 704
weight = 2
poly_data = [0, 1]

# The basis for the coefficient ring is just the power basis
# in the root of the defining polynomial above.
hecke_ring_character_values = None
aps_data = [[0], [-1], [3], [2], [1], [4], [6], [-8], [-3], [0], [5], [1], [0], [10], [0], [6], [-3], [4], [1], [15], [-4], [2], [-6], [-9], [-7], [-18], [8], [-6], [-2], [-15], [-16], [6], [9], [-14], [-6], [-10], [-5], [4], [-12], [-18], [9], [13], [-21], [20], [-6], [8], [-20], [17], [-6], [13], [-24], [6], [8], [9], [-18], [18], [6], [20], [10], [-18], [4], [0], [16], [12], [-1], [-33], [7], [2], [-12], [-14], [-21], [-36], [-19], [10], [-29], [-27], [27], [34], [18], [2], [-12], [10], [18], [29], [8], [21], [3], [-28], [-12], [23], [-3], [-12], [29], [-24], [4], [-30], [21], [-27], [-8], [16], [-8], [18], [36], [0], [-44], [17], [12], [-36], [0], [26], [14], [-32], [18], [-17], [-43], [39], [13], [3], [-3], [42], [-17], [-34], [42], [-48], [1], [-18], [37], [45], [17], [4], [34], [12], [35], [22], [36], [44], [-42], [-32], [-9], [-24], [-38], [-30], [-43], [36], [19], [-39], [-38], [24], [25], [48], [52], [-27], [4], [30], [4], [12], [-34], [18], [32], [30], [-27], [42], [-16], [15], [45], [45], [-16], [10]]
